
----------------------------------------------
-- Variables
----------------------------------------------

local moneyFrameObject;
local BBar_BASEBARSZ = 78;
local BBar_BASEBARMINSZ = 58;

local BBar_TOTALITEMS = 33;		-- Total number of items including titles (size of BBarObjects_Shown array)
local BBar_MINCURRENCYID = 10;	-- Smallest possible currency ID (below this are title IDs)
local BBar_MONEYID = 11;		-- ID of the money object
local BBar_MONEYPOS = 2;		-- Position in BBarObjects of the money object
local BBarObjects = {1, 11, 2, 395, 396, 392, 390, 3, 61, 361, 698, 402, 81, 4, 515, 241, 416, 391, 614, 615, 697, 5, 384, 398, 394, 385, 397, 393, 400, 401, 676, 677, 6};
local BBarObjects_Shown = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
local BBarTitleRegion = nil;

local BBarObjectsItems = {};
local BBarObjectsItems_Shown = {};
local BBarShowMoney = 0;
local lastSettingsItem = nil;
local defaultSettingsheight = 0;
local scrollSettingsWindow = 0;		-- Set to 1 if the settings need to be scrolled
local updateBarPosition = 0;		-- Skip updating it the first time or it'll be positioned wrong
local WindowPosStorage = {};
local TooltipStorage = {};

-- Resizing values
local rsCurrentSize = 1;		-- 0 = Small, 1 = Large
local rsAnimating = 0;			-- 1 = Shrinking or Growing
local rsAnimatingSize = 0;		-- Current width
local rsStoredWidth = 0;
local BBar_BARRESIZESTEP = 20;	-- Higher number = faster movement

--[[
local BBarObjects_Points = {395, 396, 392, 390};
local BBarObjects_Professions = {61, 361, 698, 402, 81};
local BBarObjects_Items = {515, 241, 416, 391, 614, 615, 697};
local BBarObjects_Archaeology = {384, 398, 394, 385, 397, 393, 400, 401, 676, 677};

390 = Conquest Points
392 = Honor Points
395 = Justice Points
396 = Valor Points

61 = Dalaran Jewelcrafter's Token
361 = Illustrious Jewelcrafter's Token
698 = Zen Jewelcrafter's Token
402 = Ironpaw Token
81 = Epicurean's Award

515 = Darkmoon Prize Ticket
241 = Champion's Seal
416 = Mark of the World Tree
391 = Tol Barad Commendation
614 = Mote of Darkness
615 = Essence of Corrupted Deathwing
697 = Elder Charm of Good Fortune

384 = Dwarf Archaeology Fragment
398 = Draenei Archaeology Fragment
394 = Night Elf Archaeology Fragment
385 = Troll Archaeology Fragment
397 = Orc Archaeology Fragment
393 = Fossil Archaeology Fragment
399 = Vrykul Archaeology Fragment
400 = Nerubian Archaeology Fragment
401 = Tol'vir Archaeology Fragment
676 = Pandaren Archaeology Fragment
677 = Mogu Archaeology Fragment
]]--

----------------------------------------------
-- Functions
----------------------------------------------


SLASH_BBAR_RESET1 = '/bbar';
SlashCmdList["BBAR_RESET"] = function()
	_G["BBarFrame"]:ClearAllPoints();
	_G["BBarFrame"]:SetPoint("CENTER", 0, 0);
	_G["BBarSettingsFrame"]:ClearAllPoints();
	_G["BBarSettingsFrame"]:SetPoint("CENTER", 0, 0);
end


function BBar_OnLoad(self)

	BBarTitleRegion = self:CreateTitleRegion();

	-- Store the money frame object and remove the scripts
	moneyFrameObject = _G[self:GetName().."MoneyFrame"];
	_G[moneyFrameObject:GetName().."CopperButton"]:SetScript("OnClick", nil);
	_G[moneyFrameObject:GetName().."SilverButton"]:SetScript("OnClick", nil);
	_G[moneyFrameObject:GetName().."GoldButton"]:SetScript("OnClick", nil);

	ValuesToString();	-- Setup defaults
	BBar_BuildSettingsFrame();
	
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_LOGOUT");
	self:RegisterEvent("PLAYER_MONEY");
	self:RegisterEvent("BAG_UPDATE");
	self:RegisterEvent("VARIABLES_LOADED");
	self:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
end


function BBar_OnEvent(self, event, ...)

	if( event == "PLAYER_ENTERING_WORLD" ) then
		MoneyFrame_UpdateMoney(moneyFrameObject);
		BBar_UpdateBar();
	end
	if( event == "PLAYER_LOGOUT" ) then
		BBarTitleRegion:ClearAllPoints();	-- Enable moving so the position gets saved properly
		BBarTitleRegion:SetAllPoints();
	end
	if( event == "PLAYER_MONEY" ) then
		MoneyFrame_UpdateMoney(moneyFrameObject);
		BBar_UpdateBar();
	end
	if( event == "BAG_UPDATE" ) or ( event == "CURRENCY_DISPLAY_UPDATE" ) then
		BBar_UpdateBar();		-- Would be nice to know what changed on bag update so it only updates if needed
	end
	if( event == "VARIABLES_LOADED" ) then
	--	ValuesToString();	-- Reset saved string
		StringToValues();	-- parse variable string from storage

		-- Set up the window lock
		if(BBarWindowLock == nil)	then   BBarWindowLock = 0;	end
		if(BBarWindowLock > 0) then		_G["BBarSettingsFrameLockCheck"]:SetChecked(true);
		else							_G["BBarSettingsFrameLockCheck"]:SetChecked(false);
		end
		BBar_ToggleMoving(_G["BBarSettingsFrameLockCheck"]);
	end
end


function BBar_ToggleSettings()

	if(_G["BBarSettingsFrame"]:IsShown()) then
			HideUIPanel(_G["BBarSettingsFrame"]);
	else	ShowUIPanel(_G["BBarSettingsFrame"]);
	end
end


function BBar_ToggleSize()

	-- Large -> Small
	if(rsCurrentSize == 1) then
		_G["BBarFrameResizing"]:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up");
		_G["BBarFrameResizing"]:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down");

		rsStoredWidth = _G["BBarFrame"]:GetWidth();	-- Store the current width
		rsAnimatingSize = rsStoredWidth;

		-- Hide everything
		_G["BBarFrameMoneyFrame"]:Hide();
		_G["BBarFrameSettings"]:Hide();
		
		-- Currencies
		local i = 3;	-- Start on 3 to skip the money frame
		while (BBarObjects[i] ~= nil) do
			if(BBarObjects[i] > BBar_MINCURRENCYID) then
				local outWidth, outObj = BBar_AddNewCurrencyToken(0, 0, BBarObjects[i], 0);
			end
			i = i + 1;
		end

		-- Custom items
		for i = 1, getn(BBarObjectsItems), 1 do
			if(BBarObjectsItems[i] > 0) then
				local outWidth, outObj = BBar_AddNewCurrencyToken(0, 0, -BBarObjectsItems[i], 0);
			end
		end
	-- Small -> Large
	else
		_G["BBarFrameResizing"]:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up");
		_G["BBarFrameResizing"]:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down");
		rsAnimatingSize = BBar_BASEBARMINSZ;
		-- When animation is finished, it'll update the bar to draw all currencies
	end

	-- Start the resize
	rsCurrentSize = (1 - rsCurrentSize);
	rsAnimating = 1;	-- Start animating
end

function BBar_UpdateSizeAnim(self)

	if(rsAnimating ~= 1)	then	return	end;

	StoreBBPos();
	-- Growing
	if(rsCurrentSize == 1) then
		if(rsAnimatingSize >= rsStoredWidth) then
			self:SetWidth(rsStoredWidth);
			rsAnimating = 0;	-- Stop animation
			_G["BBarFrameSettings"]:Show();
			BBar_UpdateBar();	-- Make sure it's all as it should be
		else
			rsAnimatingSize = rsAnimatingSize + BBar_BARRESIZESTEP;
			if(rsAnimatingSize > rsStoredWidth) then	rsAnimatingSize = rsStoredWidth;	end
			self:SetWidth(rsAnimatingSize);
		end
	else	-- Shrinking
		if(rsAnimatingSize <= BBar_BASEBARMINSZ) then
			self:SetWidth(BBar_BASEBARMINSZ);
			rsAnimating = 0;	-- Stop animation
		else
			rsAnimatingSize = rsAnimatingSize - BBar_BARRESIZESTEP;
			if(rsAnimatingSize < BBar_BARRESIZESTEP) then	rsAnimatingSize = BBar_BARRESIZESTEP;	end
			self:SetWidth(rsAnimatingSize);
		end
	end
	UpdateBBPos();
end


function BBar_ToggleMoving(self)

	BBarTitleRegion:ClearAllPoints();
	if(self:GetChecked()) then
		BBarTitleRegion:SetPoint("TOP", UIParent, 0, math.huge);	-- Disable Moving
		BBarWindowLock = 1;
	else
		BBarTitleRegion:SetAllPoints();	-- Enable moving
		BBarWindowLock = 0;
	end
end


function BBar_SettingsCheckOnClick(self)

	local obj = self:GetParent();
	if(obj.positionID < 100) then
		if(self:GetChecked()) then	BBarObjects_Shown[obj.positionID] = 1;
		else						BBarObjects_Shown[obj.positionID] = 0;
		end
	else
		if(self:GetChecked()) then	BBarObjectsItems_Shown[obj.positionID - 100] = 1;
		else						BBarObjectsItems_Shown[obj.positionID - 100] = 0;
		end
	end
	BBar_UpdateBar();
	ValuesToString();	-- Store changes
end


function BBar_SettingsRemoveOnClick(self)

	local iPos = self:GetParent().positionID - 100;

	-- Remove it from the bar while it's still valid
	BBarObjectsItems_Shown[iPos] = 0;
	BBar_UpdateBar();

	-- Remove it completly
	BBarObjectsItems[iPos] = 0;
	BBar_UpdateSettings(_G["BBarSettingsFrame"]);
	ValuesToString();	-- Store changes
end


function BBar_SettingsScrollUpdate()

-- Messy hack to scroll the window after an item is added.
-- Need to skip 2 frames to allow the window to be drawn before the scroll bar will move to show the new content.
	if(scrollSettingsWindow > 0) then
		if(scrollSettingsWindow == 2) then
			_G["BBarScrollFrame"]:SetVerticalScroll(100000);
			scrollSettingsWindow = 0;
		else	scrollSettingsWindow = scrollSettingsWindow + 1;
		end
	end
end


function BBar_ShowCurrencyTooltip(self)
	if((self == nil) or (self.currencyID == nil)) then	return	end
	GameTooltip:SetOwner(self, "ANCHOR_BOTTOMLEFT");
	if(self.currencyID > BBar_MINCURRENCYID)	then	GameTooltip:SetCurrencyByID(self.currencyID);	end
	if(self.currencyID < 0)						then	GameTooltip:SetItemByID(abs(self.currencyID));	end
end


function BBar_ShowResizeTooltip(self)

	GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT");
	if(rsCurrentSize == 1) then		GameTooltip:SetText("Shrink Bar", 1, 1, 1);
	else							GameTooltip:SetText("Enlarge Bar", 1, 1, 1);
	end
	GameTooltip:Show();
end


function BBar_ShowInfoTooltip(self)

	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT");
	GameTooltip:AddDoubleLine("BBar", "[ Made by Bynun ]", 0.9, 0.7, 0.1, 0.2, 1 ,0.2)

	_, TooltipStorage[1] = GameTooltipTextLeft1:GetFont();
	TooltipStorage[2] = GameTooltipTextLeft1:GetHeight();
	GameTooltipTextLeft1:SetFont(GameTooltipTextLeft1:GetFont(), 18);
	GameTooltipTextLeft1:SetHeight(24);

	_, TooltipStorage[3] = GameTooltipTextRight1:GetFont();
	TooltipStorage[4], _, _, TooltipStorage[5], TooltipStorage[6] = GameTooltipTextRight1:GetPoint(1);
	GameTooltipTextRight1:SetFont(GameTooltipTextRight1:GetFont(), 11);
	GameTooltipTextRight1:SetPoint("TOPRIGHT", -16, -14);

	GameTooltip:AddLine("|cffffffff::|r |cff44ff44/bbar|r Reset the bars position to the center of the screen.", 0.8, 0.8, 0.8);
	GameTooltip:AddLine("|cffffffff::|r Drag an item from your bag to the settings window to add it as a new currency.",  0.8, 0.8, 0.8);
	GameTooltip:AddLine("   You can then view that item's count on the main bar.",  0.8, 0.8, 0.8);
	GameTooltip:AddLine("|cffffffff::|r You can display an unlimited number of items",  0.8, 0.8, 0.8);
	GameTooltip:AddLine("|cffffffff::|r Item count includes all bag and bank items of that type.",  0.8, 0.8, 0.8);
	GameTooltip:Show();
end

function BBar_HideInfoTooltip(self)

	GameTooltip:Hide();

	-- Set it all back again
	GameTooltipTextLeft1:SetFont(GameTooltipTextLeft1:GetFont(), TooltipStorage[1]);
	GameTooltipTextLeft1:SetHeight(TooltipStorage[2]);
	GameTooltipTextRight1:SetFont(GameTooltipTextRight1:GetFont(), TooltipStorage[3]);
	GameTooltipTextRight1:SetPoint(TooltipStorage[4], TooltipStorage[5], TooltipStorage[6]);
	
	GameTooltip:ClearLines();
end


---------------------------


function BBar_UpdateBar()

	if(updateBarPosition == 1)	then	StoreBBPos();	end

	-- Add new tokens
	local priorObj = nil;
	local extraWidth = 0;
	local iPos = 1;
	local self = _G["BBarFrame"];

	if(BBarObjects_Shown[BBar_MONEYPOS] > 0) then
			_G["BBarFrameMoneyFrame"]:Show();
	else	_G["BBarFrameMoneyFrame"]:Hide();
	end

	-- Currencies
	local i = 3;	-- Start on 3 to skip the money frame
	while (BBarObjects[i] ~= nil) do
		if(BBarObjects[i] > BBar_MINCURRENCYID) then
			local outWidth, outObj = BBar_AddNewCurrencyToken(self, priorObj, BBarObjects[i], BBarObjects_Shown[i]);
			if(outWidth > 0)	then	extraWidth = extraWidth + outWidth;		end
			if(outObj ~= 0)		then	priorObj = outObj;						end
			iPos = iPos + 1;
		end
		i = i + 1;
	end

	-- Custom items
	for i = 1, getn(BBarObjectsItems), 1 do
		if(BBarObjectsItems[i] > 0) then
			local outWidth, outObj = BBar_AddNewCurrencyToken(self, priorObj, -BBarObjectsItems[i], BBarObjectsItems_Shown[i]);
			if(outWidth > 0)	then	extraWidth = extraWidth + outWidth;		end
			if(outObj ~= 0)		then	priorObj = outObj;						end
			iPos = iPos + 1;
		end
	end
	
	local moneyWidth = 0;
	if(BBarObjects_Shown[BBar_MONEYPOS] > 0)	then	moneyWidth = _G["BBarFrameMoneyFrame"]:GetWidth();	end
	self:SetWidth(BBar_BASEBARSZ + moneyWidth + extraWidth);

	if(updateBarPosition == 1)	then	UpdateBBPos();	end
	updateBarPosition = 1;	-- Make it update on all subsequent passes
end


function BBar_UpdateSettings(self)		-- Called each time the window is shown

-- Set the options check boxes
	if(BBarWindowLock > 0) then
		_G["BBarSettingsFrameLockCheck"]:SetChecked(true);
	else
		_G["BBarSettingsFrameLockCheck"]:SetChecked(false);
	end

-- Set the check boxes depending on if they are shown
	for i = 1, BBar_TOTALITEMS, 1 do
		if(BBarObjects[i] > BBar_MINCURRENCYID and BBarObjects_Shown[i] > 0) then
			_G["BBarSettingsItem"..i.."Check"]:SetChecked(true);
		else
			_G["BBarSettingsItem"..i.."Check"]:SetChecked(false);
		end
	end

	-- Custom items
	local scrollChild = _G["BBarScrollFrameChild"];
	local priorItem = lastSettingsItem;
	local scrollChildHeight = defaultSettingsheight;

	local name = "";
	local icon = "";
	local numAdded = 0;
	for i = 1, getn(BBarObjectsItems), 1 do
		if(BBarObjectsItems[i] > 0) then
			name = GetItemInfo(BBarObjectsItems[i]);
			icon = GetItemIcon(BBarObjectsItems[i]);
		end
		local returnItem = BBar_CreateSettingsItem(name, icon, scrollChild, priorItem, i + 100);
		if(returnItem ~= priorItem) then
			priorItem = returnItem;
			priorItem.currencyID = -BBarObjectsItems[i];
			scrollChildHeight = scrollChildHeight + 30;
			if(BBarObjectsItems_Shown[i] > 0) then
				_G["BBarSettingsItem"..(i + 100).."Check"]:SetChecked(true);
			else
				_G["BBarSettingsItem"..(i + 100).."Check"]:SetChecked(false);
			end
			numAdded = numAdded + 1;
		end
	end
	-- Add 'No custom items' text if needed
	local returnItem = BBar_CreateSettingsItem("No custom items", "", scrollChild, priorItem, 100);
	if(numAdded == 0) then
		returnItem:Show();
		scrollChildHeight = scrollChildHeight + 30;
	else	returnItem:Hide();
	end
	scrollChild:SetHeight(scrollChildHeight);
end


function BBar_AcceptItem()

	-- Add the dropped item to the custom items list
	local infoType, itemID = GetCursorInfo();
	if(infoType == "item") then
		-- Check it's not already added
		for i = 1, getn(BBarObjectsItems), 1 do
			if(BBarObjectsItems[i] == itemID) then
				ClearCursor();
				return;
			end
		end

		-- Add it to the end of the list
		local iPos = getn(BBarObjectsItems) + 1;
		BBarObjectsItems[iPos] = itemID;
		BBarObjectsItems_Shown[iPos] = 1;	-- Shown as default
		ClearCursor();
		BBar_UpdateBar();
		BBar_UpdateSettings(_G["BBarSettingsFrame"]);
		ValuesToString();	-- Store changes

		-- Scroll the window to the bottom to make the newly added item visable.
	--	scrollSettingsWindow = 1;
	end
end


---------------------------


function BBar_AddNewCurrencyToken(self, priorObj, currencyID, shown)

	local thisObj = _G["BBarCurrencyToken"..currencyID];

	-- Check if this button should be made or shown
	if(shown == 0) then
		if(thisObj) then thisObj:Hide(); end
		return 0, 0;
	end

	-- if this button doesn't exist yet, create it
	if( not thisObj ) then
		thisObj = CreateFrame("BUTTON", "BBarCurrencyToken"..currencyID, self, "BBarCurrencyFrameTemplate");
	else	thisObj:ClearAllPoints();
	end
	_G[thisObj:GetName().."Spacer"]:Show();		-- Incase it was hidden by being the first item earlier

	-- Get this currency info and update the button
	local objWidth = 0;
	local name, count, icon;
	if(currencyID > BBar_MINCURRENCYID) then
		name, count, icon = GetCurrencyInfo(currencyID);
		icon = "Interface\\Icons\\"..icon;
	elseif(currencyID < 0) then		-- Item
		name = GetItemInfo(abs(currencyID));
		count = GetItemCount(abs(currencyID), true);
		icon = GetItemIcon(abs(currencyID));
	end

	if( name and name ~= "" ) then
		thisObj:SetText(count);
		thisObj:SetNormalTexture(icon);
		thisObj.currencyID = currencyID;
		thisObj:Show();
		objWidth = thisObj:GetTextWidth() + thisObj:GetWidth() + 28;
		if(priorObj ~= nil)	then	thisObj:SetPoint("LEFT", priorObj, "RIGHT", priorObj:GetTextWidth() + 28, 0);
		else
			if(BBarObjects_Shown[BBar_MONEYPOS] > 0) then
				thisObj:SetPoint("LEFT", _G["BBarFrameMoneyFrame"], "RIGHT", 13, 0);
			else
				_G[thisObj:GetName().."Spacer"]:Hide();
				thisObj:SetPoint("LEFT", _G["BBarFrame"], "LEFT", 48, -1);
			end
		end
	else	thisObj:Hide();	end
	return objWidth, thisObj;
end


function BBar_CreateSettingsItem(name, icon, parent, priorItem, iPos)

	-- If this item doesn't exist yet, create it
	local item = _G["BBarSettingsItem"..iPos];
	if( not item ) then
		item = CreateFrame("Frame", "BBarSettingsItem"..iPos, parent, "BBarSettingsItemTemplate");
	else	item:ClearAllPoints();
	end
	local textItem = _G[item:GetName().."Text"];
	textItem:SetText(name);

	local obj = -1;		-- Custom item
	if(iPos < 100) then	obj = BBarObjects[iPos];	end

	if(iPos == 100) then	-- Special text only item (not title, e.g. "No custom items")
		_G[item:GetName().."Icon"]:Hide();
		_G[item:GetName().."Check"]:Hide();
		_G[item:GetName().."Remove"]:Hide();
	elseif(obj > 0 and obj < BBar_MINCURRENCYID) then		-- Title
		textItem:SetWidth(200);		-- Widen it for proper spacing
		textItem:SetJustifyH("CENTER");
		textItem:SetTextColor(0.8, 1, 0.7, 1);
		_G[item:GetName().."Check"]:Hide();
		_G[item:GetName().."Remove"]:Hide();

		if(obj == 1) then	-- The first item needs to be set it up relative to the scroll child
			item:SetPoint("TOP", parent, "TOP", 0, 4);
			return item;
		end
	else
		if(obj < 0) then	-- Custom item!
			if(BBarObjectsItems[iPos - 100] > 0) then	-- Only show valid ones
				local _, _, itemQuality = GetItemInfo(BBarObjectsItems[iPos - 100]);
				textItem:SetTextColor(GetItemQualityColor(itemQuality));
				_G[item:GetName().."Icon"]:SetTexture(icon);
				_G[item:GetName().."Check"]:Show();
				_G[item:GetName().."Remove"]:Show();
			else
				item:Hide();
				return priorItem;	-- Skip it
			end
		else				-- Currency
			local tex = _G[item:GetName().."Icon"];
			if(obj == BBar_MONEYID) then
					tex:SetTexture(icon);
					tex:SetWidth(24);
					tex:SetHeight(24);
					tex:SetTexCoord(0, 0.25, 0, 1);
			else	tex:SetTexture("Interface\\Icons\\"..icon);
			end
			_G[item:GetName().."Check"]:Show();
			_G[item:GetName().."Remove"]:Hide();
		end
		item.positionID = iPos;
	end
	item:SetPoint("TOPLEFT", priorItem, "BOTTOMLEFT", 0, -4);
	return item;
end


function BBar_BuildSettingsFrame()		-- Create the setting swindow, only called once

	local scroll = CreateFrame("ScrollFrame", "BBarScrollFrame", _G["BBarSettingsFrame"], "UIPanelScrollFrameTemplate");
	scroll:SetPoint("TOPLEFT", _G["BBarSettingsFrame"], "TOPLEFT", 14, -80);
	scroll:SetPoint("BOTTOMRIGHT", _G["BBarSettingsFrame"], "BOTTOMRIGHT", -31, 37);

	local scrollChild = CreateFrame("Frame", "BBarScrollFrameChild", scroll);
	scrollChild:EnableMouse(true)
	scrollChild:SetWidth(266);

	local scrollChildHeight = 0;
	local priorItem = scrollChild;

	-- Currencies
	for i = 1, BBar_TOTALITEMS, 1 do
		if(BBarObjects[i] < BBar_MINCURRENCYID) then
			if(BBarObjects[i] == 1) then
				priorItem = BBar_CreateSettingsItem("Money", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			elseif (BBarObjects[i] == 2) then
				priorItem = BBar_CreateSettingsItem("Points", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			elseif (BBarObjects[i] == 3) then
				priorItem = BBar_CreateSettingsItem("Professions", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			elseif (BBarObjects[i] == 4) then
				priorItem = BBar_CreateSettingsItem("Items", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			elseif (BBarObjects[i] == 5) then
				priorItem = BBar_CreateSettingsItem("Archaeology", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			elseif (BBarObjects[i] == 6) then
				priorItem = BBar_CreateSettingsItem("Custom Items", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 30;
			end
		elseif (BBarObjects[i] > BBar_MINCURRENCYID) then
			local name, count, icon;
			if(BBarObjects[i] == BBar_MONEYID) then
				name = "Total Money";
				count = 0;
				icon = "Interface\\MoneyFrame\\UI-MoneyIcons";
			else
				name, count, icon = GetCurrencyInfo(BBarObjects[i]);
			end
			priorItem = BBar_CreateSettingsItem(name, icon, scrollChild, priorItem, i);
			priorItem.currencyID = BBarObjects[i];
			scrollChildHeight = scrollChildHeight + 30;
		end
	end

	-- Store some values for use when we add the custom items
	lastSettingsItem = priorItem;
	defaultSettingsheight = scrollChildHeight;

	scrollChild:SetHeight(scrollChildHeight);
	scroll:SetScrollChild(scrollChild);
end


---------------------------


function StoreBBPos()

	-- Get the location so we can keep it left aligned when resized.
	WindowPosStorage[1], WindowPosStorage[2], WindowPosStorage[3], WindowPosStorage[4], WindowPosStorage[5] = _G["BBarFrame"]:GetPoint();
	WindowPosStorage[6] = _G["BBarFrame"]:GetWidth();
end

function UpdateBBPos()

	-- Only update if it was stored correctly
	if(WindowPosStorage[1] == nil) then	return	end;

	local Width = _G["BBarFrame"]:GetWidth();
	
	if(strfind(WindowPosStorage[1], "LEFT") ~= nil) then
		WindowPosStorage[4] = WindowPosStorage[4];		-- Do nothing
	elseif(strfind(WindowPosStorage[1], "RIGHT") ~= nil) then
		WindowPosStorage[4] = (WindowPosStorage[4] - WindowPosStorage[6]) + Width;
	else	-- TOP CENTER BOTTOM
		WindowPosStorage[4] = (WindowPosStorage[4] - (WindowPosStorage[6] / 2)) + (Width / 2);
	end
	_G["BBarFrame"]:SetPoint(WindowPosStorage[1], WindowPosStorage[2], WindowPosStorage[3], WindowPosStorage[4], WindowPosStorage[5]);
	WindowPosStorage[1] = nil;
end


-- Convert between arrays and strings for saving
function ValuesToString()

	BBarShownCurrency = "";
	for i = 1, BBar_TOTALITEMS, 1 do
		BBarShownCurrency = BBarShownCurrency..tostring(BBarObjects_Shown[i]);
	end

	BBarCustomItems = "";
	BBarShownItems = "";
	for i = 1, getn(BBarObjectsItems), 1 do
		if(BBarObjectsItems[i] > 0) then
			BBarCustomItems = BBarCustomItems..tostring(BBarObjectsItems[i]).." ";
			BBarShownItems = BBarShownItems..tostring(BBarObjectsItems_Shown[i]);
		end
	end
end

function StringToValues()

	for i = 1, BBar_TOTALITEMS, 1 do
		BBarObjects_Shown[i] = tonumber(strbyte(BBarShownCurrency, i)) - 48;	-- Convert ascii code to number
	end

	local items = { strsplit(" ", BBarCustomItems) };
	for i = 1, getn(items) - 1, 1 do	-- -1 as last item is always invalid
		if(tonumber(items[i]) > 0) then
			BBarObjectsItems[i] = tonumber(items[i]);
			BBarObjectsItems_Shown[i] = tonumber(strbyte(BBarShownItems, i)) - 48;	-- Convert ascii code to number
		end
	end
end

function _T(text)
	DEFAULT_CHAT_FRAME:AddMessage(text, 1, 1, 1);
end
